// ignore_for_file: constant_identifier_names

import 'package:ens_dart/src/ens_dart.dart';

enum CoinType {
  BTC,
  LTC,
  DOGE,
  RDD,
  DASH,
  PPC,
  NMC,
  VIA,
  GRS,
  DGB,
  MONA,
  DCR,
  XEM,
  AIB,
  SYS,
  ETH,
  ETC,
  ICX,
  XVG,
  STRAT,
  ARK,
  ATOM,
  ZIL,
  EGLD,
  ZEN,
  XMR,
  ZEC,
  LSK,
  STEEM,
  FIRO,
  RSK,
  KMD,
  XRP,
  BCH,
  XLM,
  BTM,
  OPT,
  XDAI,
  VET,
  BNB,
  CLO,
  HIVE,
  TOMO,
  HNT,
  RUNE,
  BCD,
  TT,
  FTM,
  ONE,
  ONT,
  XTZ,
  ADA,
  SC,
  QTUM,
  GXC,
  ELA,
  NAS,
  HBAR,
  IOTA,
  HNS,
  STX,
  GO,
  XCH,
  NULS,
  AVAX,
  NRG,
  ARDR,
  ZEL,
  CELO,
  WICC,
  WAN,
  WAVES,
  BSC,
  MATIC,
  ARB1,
  BTG,
  NANO,
  RVN,
  POA,
  LCC,
  EOS,
  TRX,
  BCN,
  FIO,
  BSV,
  NEO,
  NIM,
  EWT,
  ALGO,
  IOST,
  DIVI,
  IOTX,
  BTS,
  CKB,
  LUNA,
  DOT,
  VSYS,
  ABBC,
  NEAR,
  ETN,
  AION,
  KSM,
  AE,
  KAVA,
  FIL,
  AR,
  CCA,
  THETA,
  SOL,
  XHV,
  FLOW,
  IRIS,
  LRG,
  SERO,
  BDX,
  CCXX,
  SRM,
  VLX,
  BPS,
  TFUEL,
  GRIN
}

const _coinMaps = {
  'BTC': 0,
  'LTC': 2,
  'DOGE': 3,
  'RDD': 4,
  'DASH': 5,
  'PPC': 6,
  'NMC': 7,
  'VIA': 14,
  'GRS': 17,
  'DGB': 20,
  'MONA': 22,
  'DCR': 42,
  'XEM': 43,
  'AIB': 55,
  'SYS': 57,
  'ETH': 60,
  'ETC': 61,
  'ICX': 74,
  'XVG': 77,
  'STRAT': 105,
  'ARK': 111,
  'ATOM': 118,
  'ZIL': 119,
  'EGLD': 120,
  'ZEN': 121,
  'XMR': 128,
  'ZEC': 133,
  'LSK': 134,
  'STEEM': 135,
  'FIRO': 136,
  'RSK': 137,
  'KMD': 141,
  'XRP': 144,
  'BCH': 145,
  'XLM': 148,
  'BTM': 153,
  'OPT': 614,
  'XDAI': 700,
  'VET': 703,
  'BNB': 714,
  'CLO': 820,
  'HIVE': 825,
  'TOMO': 889,
  'HNT': 904,
  'RUNE': 931,
  'BCD': 999,
  'TT': 1001,
  'FTM': 1007,
  'ONE': 1023,
  'ONT': 1024,
  'XTZ': 1729,
  'ADA': 1815,
  'SC': 1991,
  'QTUM': 2301,
  'GXC': 2303,
  'ELA': 2305,
  'NAS': 2718,
  'HBAR': 3030,
  'IOTA': 4218,
  'HNS': 5353,
  'STX': 5757,
  'GO': 6060,
  'XCH': 8444,
  'NULS': 8964,
  'AVAX': 9000,
  'NRG': 9797,
  'ARDR': 16754,
  'ZEL': 19167,
  'CELO': 52752,
  'WICC': 99999,
  'WAN': 5718350,
  'WAVES': 5741564,
  'BSC': 56,
  'MATIC': 137,
  'ARB1': 42161,
  'BTG': 156,
  'NANO': 165,
  'RVN': 175,
  'POA': 178,
  'LCC': 192,
  'EOS': 194,
  'TRX': 195,
  'BCN': 204,
  'FIO': 235,
  'BSV': 236,
  'NEO': 239,
  'NIM': 242,
  'EWT': 246,
  'ALGO': 283,
  'IOST': 291,
  'DIVI': 301,
  'IOTX': 304,
  'BTS': 308,
  'CKB': 309,
  'LUNA': 330,
  'DOT': 354,
  'VSYS': 360,
  'ABBC': 367,
  'NEAR': 397,
  'ETN': 415,
  'AION': 425,
  'KSM': 434,
  'AE': 457,
  'KAVA': 459,
  'FIL': 461,
  'AR': 472,
  'CCA': 489,
  'THETA': 500,
  'SOL': 501,
  'XHV': 535,
  'FLOW': 539,
  'IRIS': 566,
  'LRG': 568,
  'SERO': 569,
  'BDX': 570,
  'CCXX': 571,
  'SRM': 573,
  'VLX': 574,
  'BPS': 576,
  'TFUEL': 589,
  'GRIN': 592
};

extension CoinTypeVal on CoinType {
  BigInt get coinTypeInt =>
      BigInt.from(_coinMaps[ENSUtils.describeEnum(this)] as int);
}
